96f92a96d3
Resolves: #2100440,#2143107,#2183546,#2203133
55 lines
2.3 KiB
Diff
55 lines
2.3 KiB
Diff
From 1ed71d6c6613509cc851a3099de8dc6a4d181f56 Mon Sep 17 00:00:00 2001
|
|
From: Yu Watanabe <watanabe.yu+github@gmail.com>
|
|
Date: Tue, 4 Apr 2023 15:03:35 +0900
|
|
Subject: [PATCH] test: add test case that journal file is created with the
|
|
requested compression algorithm
|
|
|
|
(cherry picked from commit d23a1c52a93206b0dbabcb4336752ccb796c11c3)
|
|
|
|
Resolves: #2183546
|
|
---
|
|
test/units/testsuite-04.sh | 32 ++++++++++++++++++++++++++++++++
|
|
1 file changed, 32 insertions(+)
|
|
|
|
diff --git a/test/units/testsuite-04.sh b/test/units/testsuite-04.sh
|
|
index fdc3273fea..bb41045809 100755
|
|
--- a/test/units/testsuite-04.sh
|
|
+++ b/test/units/testsuite-04.sh
|
|
@@ -179,4 +179,36 @@ sleep 3
|
|
# https://github.com/systemd/systemd/issues/15528
|
|
journalctl --follow --file=/var/log/journal/*/* | head -n1 || [[ $? -eq 1 ]]
|
|
|
|
+# https://bugzilla.redhat.com/show_bug.cgi?id=2183546
|
|
+mkdir /run/systemd/system/systemd-journald.service.d
|
|
+MID=$(cat /etc/machine-id)
|
|
+for c in "NONE" "XZ" "LZ4" "ZSTD"; do
|
|
+ cat >/run/systemd/system/systemd-journald.service.d/compress.conf <<EOF
|
|
+[Service]
|
|
+Environment=SYSTEMD_JOURNAL_COMPRESS=${c}
|
|
+EOF
|
|
+ systemctl daemon-reload
|
|
+ systemctl restart systemd-journald.service
|
|
+ journalctl --rotate
|
|
+
|
|
+ ID=$(systemd-id128 new)
|
|
+ systemd-cat -t "$ID" /bin/bash -c "for ((i=0;i<100;i++)); do echo -n hoge with ${c}; done; echo"
|
|
+ journalctl --sync
|
|
+ timeout 10 bash -c "while ! SYSTEMD_LOG_LEVEL=debug journalctl --verify --quiet --file /var/log/journal/$MID/system.journal 2>&1 | grep -q -F 'compress=${c}'; do sleep .5; done"
|
|
+
|
|
+ # $SYSTEMD_JOURNAL_COMPRESS= also works for journal-remote
|
|
+ if [[ -x /usr/lib/systemd/systemd-journal-remote ]]; then
|
|
+ for cc in "NONE" "XZ" "LZ4" "ZSTD"; do
|
|
+ rm -f /tmp/foo.journal
|
|
+ SYSTEMD_JOURNAL_COMPRESS="${cc}" /usr/lib/systemd/systemd-journal-remote --split-mode=none -o /tmp/foo.journal --getter="journalctl -b -o export -t $ID"
|
|
+ SYSTEMD_LOG_LEVEL=debug journalctl --verify --quiet --file /tmp/foo.journal 2>&1 | grep -q -F "compress=${cc}"
|
|
+ journalctl -t "$ID" -o cat --file /tmp/foo.journal | grep -q -F "hoge with ${c}"
|
|
+ done
|
|
+ fi
|
|
+done
|
|
+rm /run/systemd/system/systemd-journald.service.d/compress.conf
|
|
+systemctl daemon-reload
|
|
+systemctl restart systemd-journald.service
|
|
+journalctl --rotate
|
|
+
|
|
touch /testok
|